Index: main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml
===================================================================
--- main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml	(revision 24817)
+++ main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml	(revision 24893)
@@ -1,78 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <CollectionConfig xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
-    <metadataList>
-        <metadata lang="en" name="creator"/>
-        <metadata lang="en" name="maintainer"/>
-        <metadata lang="en" name="public">true</metadata>
-    </metadataList>
-    <displayItemList>
-        <displayItem assigned="true" lang="en" name="name">Pei-Jones-Flat</displayItem>
-    </displayItemList>
-    <search type="mgpp">
-        <level name="document">
-            <displayItem lang="en" name="name">document</displayItem>
-        </level>
-        <level name="section">
-            <displayItem lang="en" name="name">section</displayItem>
-        </level>
-        <defaultLevel name="section"/>
-        <index name="text">
-            <displayItem lang="en" name="name">text</displayItem>
-        </index>
-        <index name="Title">
-            <displayItem lang="en" name="name">titles</displayItem>
-        </index>
-        <index name="Source">
-            <displayItem lang="en" name="name">filenames</displayItem>
-        </index>
-        <index name="Plugin"/>
-        <defaultIndex name="text"/>
-        <indexOption>
-            <option name="accentfold"/>
-            <option name="casefold"/>
-            <option name="stem"/>
-        </indexOption>
-        <searchType name="plain"/>
-        <searchType name="simpleform"/>
-        <searchType name="advancedform"/>
-        <format><gsf:template match="documentNode"><td valign="top"><gsf:link type="document"><gsf:icon type="document"/></gsf:link></td><td><gsf:switch><gsf:metadata name="Title" select="ancestors" separator=": "/><gsf:when test="exists"><gsf:metadata name="Title" select="ancestors" separator=": "/>:</gsf:when></gsf:switch><gsf:link type="document"><gsf:metadata name="Title"/></gsf:link></td></gsf:template> </format>
-    </search>
-    <infodb type="gdbm"/>
-    <import>
-        <pluginList>
-            <plugin name="ZIPPlugin"/>
-            <plugin name="GreenstoneXMLPlugin"/>
-            <plugin name="TextPlugin"/>
-            <plugin name="HTMLPlugin"/>
-            <plugin name="EmailPlugin"/>
-            <plugin name="PDFPlugin"/>
-            <plugin name="RTFPlugin"/>
-            <plugin name="WordPlugin"/>
-            <plugin name="PostScriptPlugin"/>
-            <plugin name="PowerPointPlugin"/>
-            <plugin name="ExcelPlugin"/>
-			<plugin name="PagedImagePlugin"/>
-            <plugin name="ImagePlugin"/>
-            <plugin name="ISISPlugin"/>
-            <plugin name="NulPlugin"/>
-            <plugin name="OAIPlugin"/>
-            <plugin name="HTMLImagePlugin"/>
-            <plugin name="MetadataXMLPlugin"/>
-            <plugin name="ArchivesInfPlugin"/>
-            <plugin name="DirectoryPlugin"/>
-        </pluginList>
-    </import>
-    <browse>
-        <classifier name="List">
-            <option name="-metadata" value="dc.Title;Title"/>
-            <option name="-partition_type_within_level" value="approximate_size"/>
-            <option name="-bookshelf_type" value="never"/>
-        </classifier>
-        <classifier name="AZCompactList">
-            <option name="-metadata" value="Source"/>
-            <option name="-removesuffix" value="(?i)\\..*"/>
-            <option name="-buttonname" value="Source"/>
-        </classifier>
-        <format>
+<metadataList><metadata lang="en" name="creator"></metadata><metadata lang="en" name="maintainer"></metadata><metadata lang="en" name="public">true</metadata></metadataList><displayItemList><displayItem assigned="true" lang="en" name="name">Pei-Jones-Flat</displayItem></displayItemList><search type="mgpp"><level name="document"><displayItem lang="en" name="name">document</displayItem></level><level name="section"><displayItem lang="en" name="name">section</displayItem></level><defaultLevel name="section"/><index name="text"><displayItem lang="en" name="name">text</displayItem></index><index name="Title"><displayItem lang="en" name="name">titles</displayItem></index><index name="Source"><displayItem lang="en" name="name">filenames</displayItem></index><index name="Plugin"/><defaultIndex name="text"/><indexOption><option name="accentfold"/><option name="casefold"/><option name="stem"/></indexOption><searchType name="plain"/><searchType name="simpleform"/><searchType name="advancedform"/><format><gsf:template match="documentNode"><td valign="top"><gsf:link type="document"><gsf:icon type="document"/></gsf:link></td><td><gsf:switch><gsf:metadata name="Title" select="ancestors" separator=": "/><gsf:when test="exists"><gsf:metadata name="Title" select="ancestors" separator=": "/>:</gsf:when></gsf:switch><gsf:link type="document"><gsf:metadata name="Title"/></gsf:link></td></gsf:template> </format></search><infodb type="gdbm"/><import><pluginList><plugin name="ZIPPlugin"/><plugin name="GreenstoneXMLPlugin"/><plugin name="TextPlugin"/><plugin name="HTMLPlugin"><option name="-process_exp" value="(timeglider.*)(?i)(\.html?)$"/><option name="-block_exp" value="(timeglider.*)(?i)(\.jpe?g|\.png|\.gif)$"/><option name="-keep_head"/></plugin><plugin name="EmailPlugin"/><plugin name="PDFPlugin"/><plugin name="RTFPlugin"/><plugin name="WordPlugin"/><plugin name="PostScriptPlugin"/><plugin name="PowerPointPlugin"/><plugin name="ExcelPlugin"/><plugin name="PagedImagePlugin"/><plugin name="ImagePlugin"/><plugin name="ISISPlugin"/><plugin name="NulPlugin"/><plugin name="OAIPlugin"/><plugin name="HTMLImagePlugin"/><plugin name="MetadataXMLPlugin"/><plugin name="ArchivesInfPlugin"/><plugin name="DirectoryPlugin"/></pluginList></import><browse><classifier name="List"><option name="-metadata" value="dc.Title;Title"/><option name="-partition_type_within_level" value="approximate_size"/><option name="-bookshelf_type" value="never"/></classifier><classifier name="AZCompactList"><option name="-metadata" value="Source"/><option name="-removesuffix" value="(?i)\\..*"/><option name="-buttonname" value="Source"/></classifier><format>
 			<gsf:template match="documentNode">
 				<td valign="top">
@@ -140,8 +67,5 @@
 				</gsf:link>
 			</gsf:template>
-		</format>
-    </browse>
-    <display>
-        <format>
+		</format></browse><display><format>
 			<gsf:option name="sideBar" value="false"/>
 			<xsl:template name="additionalHeaderContent">
@@ -159,5 +83,5 @@
 
 				<!-- Annotator's styling and images -->
-				<link rel="stylesheet" type="text/css" href="sites/localsite/collect/peijones/js/annotator/pkg/annotator.min.css"/>
+				<link href="sites/localsite/collect/peijones/js/annotator/pkg/annotator.min.css" rel="stylesheet" type="text/css"/>
 
 				<!-- The following plugins are entirely optional -->
@@ -181,7 +105,7 @@
 				
 				<!-- Photo note scripts -->
-				<script type="text/javascript" src="sites/localsite/collect/peijones/js/documentmaker/BrowserDetect.js"><xsl:text> </xsl:text></script>
-				<script type="text/javascript" src="sites/localsite/collect/peijones/js/documentmaker/PhotoNotes-1.5.js"><xsl:text> </xsl:text></script>
-				<link rel="stylesheet" type="text/css" href="sites/localsite/collect/peijones/style/PhotoNotes-1.5.css"/>
+				<script src="sites/localsite/collect/peijones/js/documentmaker/BrowserDetect.js" type="text/javascript"><xsl:text> </xsl:text></script>
+				<script src="sites/localsite/collect/peijones/js/documentmaker/PhotoNotes-1.5.js" type="text/javascript"><xsl:text> </xsl:text></script>
+				<link href="sites/localsite/collect/peijones/style/PhotoNotes-1.5.css" rel="stylesheet" type="text/css"/>
 				
 				<!-- Zoom scripts -->
@@ -483,5 +407,5 @@
 					<img style="width: {$screenImageWidth}; height: {$screenImageHeight};">
 									<xsl:attribute name="src">
-										<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata select="root" name="assocfilepath"/>/<gsf:metadata name="Screen"/>
+										<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata name="assocfilepath" select="root"/>/<gsf:metadata name="Screen"/>
 									</xsl:attribute>
 					</img>
@@ -498,5 +422,5 @@
 							<img style="width: {$screenImageWidth}; height: {$screenImageHeight};">
 									<xsl:attribute name="src">
-										<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata select="root" name="assocfilepath"/>/<gsf:metadata name="Screen"/>
+										<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata name="assocfilepath" select="root"/>/<gsf:metadata name="Screen"/>
 									</xsl:attribute>
 							</img>	
@@ -507,5 +431,5 @@
 								<img style="width: {$imageWidth}; height: {$imageHeight};">
 									<xsl:attribute name="src">
-										<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata select="root" name="assocfilepath"/>/<gsf:metadata name="srclinkFile"/>
+										<xsl:value-of disable-output-escaping="yes" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>/index/assoc/<gsf:metadata name="assocfilepath" select="root"/>/<gsf:metadata name="srclinkFile"/>
 									</xsl:attribute>
 								</img>
@@ -513,13 +437,9 @@
 						</div>
 					</div>
-					<input type="button" value="Tag Photo!" style="margin-left:30px;" onclick="AddNote();" />
+					<input onclick="AddNote();" style="margin-left:30px;" type="button" value="Tag Photo!"/>
 				<!--</xsl:if>-->
 			</xsl:template>
 			
-		</format>
-    </display>
-    <replaceListRef id="gs2-standard"/>
-    <replaceListRef id="gs2-image"/>
-    <serviceRackList>
+		</format></display><replaceListRef id="gs2-standard"/><replaceListRef id="gs2-image"/><serviceRackList>
         <!-- comment out the following serviceRack if you want to disable OAI for this collection -->
         <serviceRack name="OAIPMH">
@@ -552,4 +472,3 @@
             </ListMetadataFormats>
         </serviceRack>
-    </serviceRackList>
-</CollectionConfig>
+    </serviceRackList></CollectionConfig>